/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.device.service.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;
import java.util.List;
import java.util.Set;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.base.BaseDTO;
import me.zhengjie.modules.dm.floor.domain.DmFloor;
import me.zhengjie.modules.dm.floor.service.dto.DmFloorDto;
import me.zhengjie.modules.dm.printingQueue.domain.DmPrintingQueue;
import me.zhengjie.modules.dm.printingQueue.service.dto.DmPrintingQueueDto;

/**
* @website https://el-admin.vip
* @description /
* @author xwx
* @date 2021-03-12
**/
@Data
public class DmDeviceDto extends BaseDTO implements Serializable {

    /** 主键 */
    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long id;

    /** 设备编号 */
    private String code;

    /** 设备名称 */
    private String name;

    /** 产品类型 */
    private String style;

//    /** 设备安装位置 */
//    private String buildAddress;

    private DmFloorDto floor;

    /** 设备状态 */
    private String status;

    /** 安装时间 */
    private Timestamp buildDate;

    /** 保修期 */
    private String warranty;

    /** 最新维修日期 */
    private Timestamp lastGuarantee;

    /** 运维人员 */
    private String operator;

    /** 联系方式 */
    private String linkType;

    /** 备注 */
    private String remark;

   /** 未打印数 */
    private Integer unPrintingCount;
    /** 已打印数 */
    private Integer yiPrintingCount;
    /** 是否是公共打印机 */
    private String isCommonPrinter;
    /** 打印机ip */
    private String printingIp;
    /** 读卡器ip */
    private String cardIp;
    /** 打印机地址 */
    private String printingAddress;

    /** 备注 */
    private List<DmPrintingQueueDto> queueList;

}
