/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.device.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import me.zhengjie.annotation.Query;

/**
* @website https://el-admin.vip
* @author xwx
* @date 2021-03-12
**/
@Data
public class DmDeviceQueryCriteria{

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String code;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String name;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String style;

    @Query(propName = "floorId", type = Query.Type.EQUAL, joinName = "floor")
    private Long floorId;

    /** 精确 */
    @Query
    private String status;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String warranty;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String operator;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String linkType;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String remark;
    /** BETWEEN */
    @Query(type = Query.Type.BETWEEN)
    private List<Timestamp> buildDate;
    /** BETWEEN */
    @Query(type = Query.Type.BETWEEN)
    private List<Timestamp> lastGuarantee;
}