/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.printingApproval.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;
import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.base.BaseDTO;
import me.zhengjie.modules.dm.printingRequest.domain.DmPrintingRequest;
import me.zhengjie.modules.dm.printingRequest.service.dto.DmPrintingRequestDto;
import me.zhengjie.modules.dm.user.service.dto.DmUserDto;

/**
* @website https://el-admin.vip
* @description /
* @author xwx
* @date 2021-03-17
**/
@Data
public class DmPrintingApprovalDto extends BaseDTO implements Serializable {

    /** 主键 */
    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long id;

    /** 文印申请主键 */
    private DmPrintingRequestDto printingRequest;

    /** 任务编号 */
    private String taskCode;

    /** 审批意见 */
    private String approvalRemark;

    private String approveSuggest;

    /** 审批状态 */
    private String approvalStatus;

    /** 审批节点 */
    private Integer approvalLeave;

    /** 是否为叶子节点 */
    private String lastLeave;

    /** 是否为最新审批 */
    private String isNew;

    /** 审批人 */
    private DmUserDto approvalUser;

    /** 任务ID */
    private String taskId;

    /** 任务实例id")*/
    private String procInstId;
}