/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.printingQueue.repository;

import me.zhengjie.modules.dm.printingQueue.domain.DmPrintingQueue;
import me.zhengjie.modules.dm.printingQueue.service.dto.DmPrintingQueueDto;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
* @website https://el-admin.vip
* @author xwx
* @date 2021-03-17
**/
public interface DmPrintingQueueRepository extends JpaRepository<DmPrintingQueue, Long>, JpaSpecificationExecutor<DmPrintingQueue> {

    @Query(nativeQuery =true,value="SELECT a.*  from dm_printing_queue a LEFT JOIN dm_printing_request b on a.request_id = b.id where a.`status` in ('00','01') and b.printer_code = ?1" )
    List<DmPrintingQueue> findUnprint(Long deviceId);

    @Query(value = "SELECT COUNT(1) FROM dm_printing_queue WHERE request_id = ?1",nativeQuery = true)
    Integer selecIsNotPrintingQueue(Long requestId);

    @Query(value = "SELECT task_name FROM dm_printing_request WHERE id in (?1)",nativeQuery = true)
    List selectPrintingQueueName(Long[] requestId);
}