/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.printingRequest.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;
import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.base.BaseDTO;
import me.zhengjie.domain.LocalStorage;
import me.zhengjie.modules.dm.device.service.dto.DmDeviceDto;
import me.zhengjie.modules.dm.user.service.dto.DmUserDto;
import me.zhengjie.modules.system.service.dto.UserDto;
import me.zhengjie.service.dto.LocalStorageDto;

/**
* @website https://el-admin.vip
* @description /
* @author xwx
* @date 2021-03-15
**/
@Data
public class DmPrintingRequestDto extends BaseDTO implements Serializable {

    /** 主键 */
    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long id;

    /** 任务编号 */
    private String taskCode;

    /** 任务名称 */
    private String taskName;

    /** 文档总页数 */
    private Integer filePageNum;

    /** 文档份数 */
    private Integer fileRepeatNum;

    /** 打印机 */
    private DmDeviceDto device;

    /** 审批人 */
    private DmUserDto approvalUser;

    /** 审批意见 */
    private String approvalRemark;

    /** 发起人 */
    private DmUserDto requestUser;

    /** 文件 */
    private LocalStorageDto file;

    /** 目前状态 */
    private String status;

    /** 备注 */
    private String remark;

    /** 任务ID */
    private String taskId;

    /** 任务实例id */
    private String procInstId;

    /** 是否添加审批人 */
    private Boolean isHasApproval ;
}