/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.printingRequest.service.dto;

import lombok.Data;
import java.util.List;
import me.zhengjie.annotation.Query;

/**
* @website https://el-admin.vip
* @author xwx
* @date 2021-03-15
**/
@Data
public class DmPrintingRequestQueryCriteria{

    @Query
    private Long id;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String taskCode;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String taskName;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private Integer filePageNum;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private Integer fileRepeatNum;

    /** 精确 */
    @Query(type = Query.Type.INNER_LIKE, propName = "code", joinName = "device")
    private String printerCode;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String approvalUser;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE,joinName = "requestUser",propName = "id")
    private String requestUser;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String createBy;

    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String updateBy;

    /** 精确 */
    @Query
    private String status;

    @Query
    private String printingRequest;

    @Query
    private String taskId;
}